﻿using System.CodeDom.Compiler;
using System.Collections;
using System.Security;
using System.Text;

namespace ClassLibrary1
{
    public class Class1
    {
        public static IEnumerable GetEnumerable(IEnumerator enumerator)
        {
            while (enumerator.MoveNext())
                yield return enumerator.Current;
        }
        public static void DoTest()
        {
            System.Diagnostics.Trace.WriteLine("DoTest Called");

            AssertFullTrust().Assert();

            //Assembly asm = typeof(Class1).Assembly;

            //foreach (object obj in GetEnumerable(asm.Evidence.GetHostEnumerator()))
            //{
            //    if (obj is Hash == false)
            //    {
            //        System.Diagnostics.Trace.WriteLine(obj.ToString());
            //    }
            //}

            CodeDomProvider codeProvider = CodeDomProvider.CreateProvider("CSharp");
            if (codeProvider == null)
            {
                return;
            }

            CompilerInfo langCompilerInfo = CodeDomProvider.GetCompilerInfo("CSharp");

            System.CodeDom.Compiler.CompilerParameters parameters = langCompilerInfo.CreateDefaultCompilerParameters();
            parameters.OutputAssembly = @"C:\temp\test_2.dll";

            string srcContents = "class Person { };";

            CompilerResults results = codeProvider.CompileAssemblyFromSource(parameters, srcContents);

            if (results.Errors.HasErrors == true && results.Errors.Count > 0)
            {
                StringBuilder errorText = new StringBuilder();
                bool hasError = true;

                foreach (CompilerError CompErr in results.Errors)
                {
                    errorText.AppendLine("Line number " + CompErr.Line +
                                ", Error Number: " + CompErr.ErrorNumber +
                                ", '" + CompErr.ErrorText);

                    hasError = CompErr.ErrorNumber != "CS0016";
                }

                if (hasError == true)
                {
                    return;
                }
            }

        }

        private static NamedPermissionSet AssertFullTrust()
        {
            NamedPermissionSet ps = new NamedPermissionSet("FullTrust");
            return ps;
        }
    }
}
